<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>

<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>
<%@ page import="java.text.SimpleDateFormat"%>

<%@ page import="org.apache.commons.fileupload.disk.*"%>
<%@ page import="org.apache.commons.fileupload.servlet.*"%>
<%@ page import="org.apache.commons.fileupload.*"%>

<%@ page import="witersen.vo.*"%>
<%@ page import="witersen.factory.*"%>
<%@ page import="other.IPTimeStamp"%>

<%
    request.setCharacterEncoding("UTF-8");
%>
<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>首页</title>
<script type="text/javascript">
	function edit(object) {
		//获取值
		var eno = object.parentNode.parentNode.children[0].textContent;
		var old_imgUrl = object.parentNode.parentNode.children[1].children[0]
				.getAttribute("src");
		var ename = object.parentNode.parentNode.children[2].textContent;
		var ejob = object.parentNode.parentNode.children[3].textContent;
		var hiredate = object.parentNode.parentNode.children[4].textContent;
		var comm = object.parentNode.parentNode.children[5].textContent;
		//显示到页面
		document.getElementById("edit_table").children[0].children[0].children[0].children[0]
				.setAttribute("value", eno);
		document.getElementById("edit_table").children[0].children[0].children[1].children[0]
				.setAttribute("value", ename);
		document.getElementById("edit_table").children[0].children[0].children[2].children[0]
				.setAttribute("value", ejob);
		document.getElementById("edit_table").children[0].children[0].children[3].children[0]
				.setAttribute("value", hiredate);
		document.getElementById("edit_table").children[0].children[0].children[4].children[0]
				.setAttribute("value", comm);
		document.getElementById("edit_table").children[0].children[0].children[6].children[0]
				.setAttribute("value", old_imgUrl);
		//移除不可点击属性
		document.getElementById("edit_table").children[0].children[0].children[7].children[0]
				.removeAttribute("disabled");
	}
</script>
</head>
<body>
	<form action="index.jsp" method="post" enctype="multipart/form-data">
		<table style="margin: 0 auto; width: 65%;">
			<tr>
				<td><input name="eno" type="text" placeholder="输入雇员编号"></input></td>
				<td><input name="ename" type="text" placeholder="输入雇员姓名"></input></td>
				<td><input name="ejob" type="text" placeholder="输入雇员工作"></input></td>
				<td><input name="hiredate" type="text" placeholder="输入雇佣日期"></input></td>
				<td><input name="comm" type="text" placeholder="输入基本工资"></input></td>
				<td><input name="imgUrl" type="file"></input></td>
				<td><input type="submit" value="添加雇员"></input></td>
				<%
				    if (request.getContentLength() != -1) {//有请求

				    DiskFileItemFactory factory = new DiskFileItemFactory(); //创建磁盘工厂
				    factory.setRepository(new File(this.getServletContext().getRealPath("/") + "uploadtemp")); //设置临时文件夹
				    ServletFileUpload upload = new ServletFileUpload(factory); //创建处理工具
				    upload.setFileSizeMax(3145728); //设置最大上传大小为3MB
				    List<FileItem> items = upload.parseRequest(request); //接收全部内容 (执行完此代码 表单提交的文件已经保存到临时文件夹)
				    Iterator<FileItem> iter = items.iterator(); //将全部的内容变为Iterator实例
				    IPTimeStamp its = new IPTimeStamp(request.getRemoteAddr()); //实例化对象
				    Iterator<FileItem> uuu = iter;

				    Map<String, String> m1 = new HashMap<String, String>();//由于FileUpload无法准确的获取表单参数 所以我们需要使用Map手动存储表单key-value
				    String filedName = ""; //表单控件名称
				    String value = ""; //表单普通文本字段值
				    String fileName = ""; //表单中文件名称值
				    String absolutePath = ""; //文件的保存路径 绝对路径
				    String relativePath = ""; //保存到数据库的图片相对路径
				    String houzhui = ""; //文件后缀
				    String isVali = "1"; //数据是否符合条件可以进行数据库操作

				    //进行表单数据获取和文件保存
				    while (iter.hasNext()) {

				        FileItem item = iter.next();
				        filedName = item.getFieldName(); //得到表单控件的名称

				        if (!item.isFormField()) {//如果为文件

				    fileName = item.getName().trim(); //取得文件名称

				    if ("".equals(fileName) || fileName == null) {//如果没有上传文件

				        //向数据库存储默认图片的路径
				        relativePath = "upload" + File.separator + "default.png";
				        m1.put("imgUrl", relativePath);
				        m1.put("isVali", isVali);
				    } else {//如果上传了文件 这里要进行文件的后缀判断 只接受图片后缀的文件

				        File saveFile = null; //定义保存的文件
				        InputStream input = null; //定义文件的输入流 用于读取源文件
				        OutputStream output = null; //定义文件的输出流 用于保存文件

				        houzhui = item.getName().split("\\.")[1];
				        relativePath = "upload" + File.separator + its.getIPTimeRand() + "." + houzhui;
				        absolutePath = this.getServletContext().getRealPath("/") + relativePath;

				        input = item.getInputStream(); //取得上传文件的输入流
				        output = new FileOutputStream(new File(absolutePath));

				        byte data[] = new byte[512]; //分块保存
				        int temp = 0;
				        while ((temp = input.read(data, 0, 512)) != -1) {
				            output.write(data);
				        }

				        m1.put("imgUrl", relativePath);

				        input.close(); //关闭输入流
				        output.close(); //关闭输出流

				        if (!("png".equalsIgnoreCase(houzhui) || "jpg".equalsIgnoreCase(houzhui)
				            || "jpeg".equalsIgnoreCase(houzhui))) {
				            isVali = "0";
				        }
				        m1.put("isVali", isVali);
				    }
				        } else {//如果不为文件 取得表单的字段内容

				    value = item.getString("UTF-8"); //取得表单的内容
				    m1.put(filedName, value); //存入map

				        }
				    }

				    //根据保存的参数判断是进行数据插入还是数据更新
				    if (m1.get("edit_eno") == null) {
				        //数据插入
				        if (m1.get("isVali").equals("1")) {
				    boolean flag = false;
				    Emp emp = null;
				    emp = new Emp();
				    emp.setEmpno(Integer.parseInt(m1.get("eno")));
				    emp.setEname(m1.get("ename"));

				    SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
				    java.util.Date date = sdf.parse(m1.get("hiredate"));
				    long lg = date.getTime();
				    emp.setHiredate(new java.sql.Date(lg));

				    emp.setJob(m1.get("ejob"));
				    emp.setComm(Float.parseFloat(m1.get("comm")));
				    emp.setImgUrl(m1.get("imgUrl"));

				    flag = DAOFactory.getIEmpDAOInstance().doCreate(emp);
				    if (flag) {
				        out.print("<td style=\"color: red;\">添加成功</td>");
				    } else {
				        out.print("<td style=\"color: red;\">添加失败</td>");
				    }
				        } else {
				    out.print("<td style=\"color: red;\">添加失败</td>");
				        }
				    } else {
				        //数据更新
				        if (m1.get("isVali").equals("1")) {
				    boolean flag = false;
				    Emp emp = null;
				    emp = new Emp();
				    emp.setEmpno(Integer.parseInt(m1.get("edit_eno")));
				    emp.setEname(m1.get("edit_ename"));

				    SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
				    java.util.Date date = sdf.parse(m1.get("edit_hiredate"));
				    long lg = date.getTime();
				    emp.setHiredate(new java.sql.Date(lg));

				    emp.setJob(m1.get("edit_ejob"));
				    emp.setComm(Float.parseFloat(m1.get("edit_comm")));

				    if ("".equals(fileName) || fileName == null) {
				        emp.setImgUrl(m1.get("old_imgUrl"));
				    } else {
				        emp.setImgUrl(m1.get("imgUrl"));
				    }

				    flag = DAOFactory.getIEmpDAOInstance().updateInfo(emp);
				    if (flag) {
				        out.print("<td style=\"color: red;\">更新成功</td>");
				    } else {
				        out.print("<td style=\"color: red;\">更新失败</td>");
				    }
				        } else {
				    out.print("<td style=\"color: red;\">更新失败</td>");
				        }
				    }
				}
				%>
			</tr>
		</table>
	</form>
	<form action="index.jsp" method="post" enctype="multipart/form-data">
		<table id="edit_table" style="margin: 0 auto; width: 65%;">
			<tr>
				<td><input name="edit_eno" type="text" placeholder="要修改的雇员编号"
					readonly="readonly"></input></td>
				<td><input name="edit_ename" type="text" placeholder="雇员姓名"></input></td>
				<td><input name="edit_ejob" type="text" placeholder="雇员工作"></input></td>
				<td><input name="edit_hiredate" type="text" placeholder="雇佣日期"></input></td>
				<td><input name="edit_comm" type="text" placeholder="基本工资"></input></td>
				<td><input name="imgUrl" type="file"></input></td>
				<td><input name="old_imgUrl" type="hidden"></input></td>
				<td><input type="submit" value="确认修改" disabled="disabled"></input></td>
			</tr>
		</table>
	</form>
	<form action="query.jsp" method="post">
		<table style="margin: 0 auto; width: 40%;">
			<tr>
				<td><input name="keywords" type="text"
					placeholder="根据雇员姓名进行模糊查询" style="width: 84%;"></input></td>
				<td><input type="submit" value="查询" style="width: 60%;"></input></td>
			</tr>
		</table>
	</form>
	<table id="mytab" border="1" style="margin: 0 auto; width: 50%;">
		<tr>
			<td style="width: 70px;">雇员编号</td>
			<td style="width: 100px;">雇员头像</td>
			<td>雇员姓名</td>
			<td>雇员工作</td>
			<td>雇佣日期</td>
			<td>基本工资</td>
			<td>操作</td>
		</tr>
		<%
		    
		int pageSize = 5; //每一页显示多少条数据
		int current = 1; //当前处于第几页

		if (request.getParameter("current") != null) {
		    current = Integer.parseInt(request.getParameter("current"));
		    pageSize = Integer.parseInt(request.getParameter("pageSize"));
		}
		
		int total = DAOFactory.getIEmpDAOInstance().getTotalCount(""); //总记录条数
		int totalPage = (total % pageSize == 0) ? (total / pageSize) : (total / pageSize + 1); //总页数
		int prePage = 1; //上一页的值
		int nextPage = 1; //下一页的值
		
		prePage = (current > 1) ? (current - 1) : current;
		nextPage = (current == totalPage) ? current : (current + 1);

		List<Emp> all = DAOFactory.getIEmpDAOInstance().findAll("", pageSize, current);
		Iterator<Emp> iterr = all.iterator();
		while (iterr.hasNext()) {
		    Emp emp = iterr.next();
		%>
		<tr>
			<td><%=emp.getEmpno()%></td>
			<td><img alt="" src="<%=emp.getImgUrl()%>"
				style="width: 90px; height: 90px;"></td>
			<td><%=emp.getEname()%></td>
			<td><%=emp.getJob()%></td>
			<td><%=emp.getHiredate()%></td>
			<td><%=emp.getComm()%></td>
			<td>
				<button onclick="edit(this)">修改信息</button>
			</td>
		</tr>
		<%
		    }
		%>
	</table>
	<div style="margin: 0 auto; width: 25%;">
		<span>每页<%=pageSize%>条
		</span> <span>共<%=total%>条
		</span> <span>当前第<%=current%>页
		</span> <span>共<%=totalPage%>页
		</span> <a href="index.jsp?current=<%=prePage%>&pageSize=<%=pageSize%>">上一页</a>
		<a href="index.jsp?current=<%=nextPage%>&pageSize=<%=pageSize%>">下一页</a>
	</div>
</body>
</html>