package other;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Random;

public class IPTimeStamp {
    private SimpleDateFormat sdf = null; // 定义SimpleDateFormat 对象
    private String ip = null;

    public IPTimeStamp() {}

    public IPTimeStamp(String ip) { // 接收IP地址
        this.ip = ip;
    }

    public String getIPTimeRand() { // 得到IP地址+时间戳+三位随机数
        StringBuffer buf = new StringBuffer();
        if (this.ip != null) {
            String s[] = this.ip.split("\\.");
            for (int i = 0; i < s.length; i++) {
                buf.append(this.addZero(s[i], 3));
            }
        }
        buf.append(this.getTimeStamp());
        Random r = new Random();
        for (int i = 0; i < 3; i++) {
            buf.append(r.nextInt(10));
        }
        return buf.toString();
    }

    private String addZero(String str, int len) { // 补0操作
        StringBuffer s = new StringBuffer();
        s.append(str);
        while(s.length()<len) {
            s.insert(0, "0");
        }
        return s.toString();
    }

    public String getDate() { // 获取当前的系统时间
        this.sdf = new SimpleDateFormat("yyy-MM-dd HH:mm:ss.SSS");
        return this.sdf.format(new Date());
    }

    public String getTimeStamp() { // 获取时间戳
        this.sdf = new SimpleDateFormat("yyMMddHHmmssSSS");
        //System.currentTimeMillis();
        //Calendar.getInstance().getTimeInMillis();
        //new Date().getTime();
        return this.sdf.format(new Date());
    }
}
