<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>
<%@ page import="witersen.vo.*,witersen.factory.*,java.util.*"%>
<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>查询</title>
</head>
<%
    //由于查询还需要分页显示 分页跳转使用的方式为带参数跳转 跳转后关键词失效 所以这里可以使用session来临时存储关键词
request.setCharacterEncoding("UTF-8");
String keywords = "";
if (request.getParameter("keywords") != null || "".equals(request.getParameter("keywords"))) {
    keywords = request.getParameter("keywords");
    session.setAttribute("saveKeywords", keywords);
} else {
    if (session.getAttribute("saveKeywords") != null) {
        keywords = (String)session.getAttribute("saveKeywords");
    }
}
%>
<%
    int total = DAOFactory.getIEmpDAOInstance().getTotalCount(keywords); //总记录条数
int pageSize = 5; //每一页显示多少条数据
int current = 1; //当前处于第几页
int totalPage = (total % pageSize == 0) ? (total / pageSize) : (total / pageSize + 1); //总页数
int prePage = 1; //上一页的值
int nextPage = 1; //下一页的值
%>
<%
if (request.getParameter("current") != null) {
    current = Integer.parseInt(request.getParameter("current"));
}
prePage = (current > 1) ? (current - 1) : current;
nextPage = (current == totalPage) ? current : (current + 1);
%>
<body>
	<table id="mytab" border="1" style="margin: 0 auto; width: 50%;">
		<tr>
			<td style="width: 70px;">雇员编号</td>
			<td style="width: 100px;">雇员头像</td>
			<td>雇员姓名</td>
			<td>雇员工作</td>
			<td>雇佣日期</td>
			<td>基本工资</td>
		</tr>
		<%
		    List<Emp> all = DAOFactory.getIEmpDAOInstance().findAll(keywords, pageSize, current);
		Iterator<Emp> iter = all.iterator();
		while (iter.hasNext()) {
		    Emp emp = iter.next();
		%>
		<tr>
			<td><%=emp.getEmpno()%></td>
			<td><img alt="" src="<%=emp.getImgUrl()%>" style="width: 90px;height: 90px;"></td>
			<td><%=emp.getEname()%></td>
			<td><%=emp.getJob()%></td>
			<td><%=emp.getHiredate()%></td>
			<td><%=emp.getComm()%></td>
		</tr>
		<%
		    }
		%>
	</table>
	<div style="margin: 0 auto; width: 25%;">
		<span>每页<%=pageSize%>条
		</span> <span>共<%=total%>条
		</span> <span>当前第<%=current%>页
		</span> <span>共<%=totalPage%>页
		</span> <a href="query.jsp?current=<%=prePage%>&pageSize=<%=pageSize%>">上一页</a>
		<a href="query.jsp?current=<%=nextPage%>&pageSize=<%=pageSize%>">下一页</a>
		<a href="index.jsp">返回首页</a>
	</div>
</body>
</html>